tiles = {
	size = 30,
	definitions = {
		{
			image = "blank",
			interact = function() end
		},
		{
			image = "track-tank-n",
			click = function(x, y) laser.fire(x, y, 0, -1) end,
			interact = function() laser.active = false level.setTile(laser.x, laser.y, tiles.TRACK_TANK_N_DAMAGED) sounds.play("explos") end,
			helpPage = 2
		},
		{
			image = "track-tank-e",
			click = function(x, y) laser.fire(x, y, 1, 0) end,
			interact = function() laser.active = false level.setTile(laser.x, laser.y, tiles.TRACK_TANK_E_DAMAGED) sounds.play("explos") end,
			helpPage = 2
		},
		{
			image = "track-tank-s",
			click = function(x, y) laser.fire(x, y, 0, 1) end,
			interact = function() laser.active = false level.setTile(laser.x, laser.y, tiles.TRACK_TANK_S_DAMAGED) sounds.play("explos") end,
			helpPage = 2
		},
		{
			image = "track-tank-w",
			click = function(x, y) laser.fire(x, y, -1, 0) end,
			interact = function() laser.active = false level.setTile(laser.x, laser.y, tiles.TRACK_TANK_W_DAMAGED) sounds.play("explos") end,
			helpPage = 2
		},
		{
			image = "track-we",
			interact = function() laser.active = false level.setTile(laser.x, laser.y, tiles.TRACK_WE_DAMAGED) sounds.play("explos") end,
			helpPage = 2
			
		}, {
			image = "track-ns",
			interact = function() laser.active = false level.setTile(laser.x, laser.y, tiles.TRACK_NS_DAMAGED) sounds.play("explos") end,
			helpPage = 2
		},
		{
			image = "mirror-nw",
			interact = function()
				if laser.dx > 0 or laser.dy > 0 then
					laser.reflectNWSE()
				else
					laser.active = false
					level.moveMirror(laser.x, laser.y, laser.dx, laser.dy)
				end
			end,
			helpPage = 3
		},
		{
			image = "mirror-ne",
			interact = function()
				if laser.dx < 0 or laser.dy > 0 then
					laser.reflectNESW()
				else
					laser.active = false
					level.moveMirror(laser.x, laser.y, laser.dx, laser.dy)
				end
			end,
			helpPage = 3
		},
		{
			image = "mirror-se",
			interact = function()
				if laser.dx < 0 or laser.dy < 0 then
					laser.reflectNWSE()
				else
					laser.active = false
					level.moveMirror(laser.x, laser.y, laser.dx, laser.dy)
				end
			end,
			helpPage = 3
		},
		{
			image = "mirror-sw",
			interact = function()
				if laser.dx > 0  or laser.dy < 0 then
					laser.reflectNESW()
				else
					laser.active = false
					level.moveMirror(laser.x, laser.y, laser.dx, laser.dy)
				end
			end,
			helpPage = 3
		},
		{
			image = "moveable",
			interact = function()
				if level.moveTile(laser.x, laser.y, laser.dx, laser.dy) then
					sounds.play("bzzt")
				else
					sounds.play("grate")
				end
				laser.active = false
			end,
			helpPage = 3
		},
		{
			image = "steel",
			interact = function()
				sounds.play("bzzt")
				laser.active = false
			end,
			helpPage = 3
		},
		{
			image = "brick",
			interact = function()
				level.incrementTile(laser.x, laser.y, 1)
				laser.active = false
				sounds.play("explos")
			end,
			helpPage = 4
		},
		{
			image = "brick-damaged",
			interact = function()	
				level.setTile(laser.x, laser.y, 1)
				laser.active = false
				sounds.play("explos")
			end,
			helpPage = 4
		},
		{
			image = "iris",
			interact = function()
				level.setTile(laser.x, laser.y, tiles.IRIS_OPEN)
				laser.active = false
				sounds.play("irismove")
			end,
			helpPage = 4
		},

		{
			image = "arrow-n",
			click = function(x, y) level.moveTrackTank(x, y, 0, -1) end,
			helpPage = 5
		},
		{
			image = "arrow-e",
			click = function(x, y) level.moveTrackTank(x, y, 1, 0) end,
			helpPage = 5
		},
		{
			image = "arrow-s",
			click = function(x, y) level.moveTrackTank(x, y, 0, 1) end,
			helpPage = 5
		},
		{
			image = "arrow-w",
			click = function(x, y) level.moveTrackTank(x, y, -1, 0) end,
			helpPage = 5
		},
		{
			image = "pod-n",
			click = function(x, y) laser.fire(x, y, 0, -1) end,
			interact = function() level.incrementTile(laser.x, laser.y, 1) laser.active = false end,
			helpPage = 4
		},
		{
			image = "pod-e",
			click = function(x, y) laser.fire(x, y, 1, 0) end,
			interact = function() level.incrementTile(laser.x, laser.y, 1) laser.active = false end,
			helpPage = 4
		},
		{
			image = "pod-s",
			click = function(x, y) laser.fire(x, y, 0, 1) end,
			interact = function() level.incrementTile(laser.x, laser.y, 1) laser.active = false end,
			helpPage = 4
		},
		{
			image = "pod-w",
			click = function(x, y) laser.fire(x, y, -1, 0) end,
			interact = function() level.incrementTile(laser.x, laser.y, -3) laser.active = false end,
			helpPage = 4
		},
		{
			image = "gate",
			interact = function()
				level.setTile(laser.x, laser.y, tiles.STEEL)
				level.setTemporaryTile(laser.x, laser.y, tiles.GATE)
				sounds.play("irismove")
			end,
			helpPage = 5
		},
		{
			image = "acid",
			interact = function()
				laser.active = false
				local newX = laser.x + laser.dx
				local newY = laser.y + laser.dy
				if newX < 0 or newX >= level.width or newY < 0 or newY >= level.height then
					level.setTile(laser.x, laser.y, tiles.BLANK)
					sounds.play("slime")
				else
					local hitTile = level.getTile(newX, newY)
					local acidMoved = true
					if hitTile == tiles.BLANK then
						level.setTile(newX, newY, level.getTile(laser.x, laser.y))
						sounds.play("slime")
					elseif hitTile == tiles.ACID then
						acidMoved = false
						sounds.play("bzzt")
					else
						level.setTile(newX, newY, tiles.BLANK)
						sounds.play("burp")
					end
					if acidMoved then
						level.setTile(laser.x, laser.y, tiles.BLANK)
						if laser.dy < 0 then
							level.setTemporaryTile(laser.x, laser.y, tiles.ACID_MOVE_S)
							level.setTemporaryTile(newX, newY, tiles.ACID_MOVE_N)
						elseif laser.dx > 0 then
							level.setTemporaryTile(laser.x, laser.y, tiles.ACID_MOVE_W)
							level.setTemporaryTile(newX, newY, tiles.ACID_MOVE_E)
						elseif laser.dy > 0 then
							level.setTemporaryTile(laser.x, laser.y, tiles.ACID_MOVE_N)
							level.setTemporaryTile(newX, newY, tiles.ACID_MOVE_S)
						elseif laser.dx < 0 then
							level.setTemporaryTile(laser.x, laser.y, tiles.ACID_MOVE_E)
							level.setTemporaryTile(newX, newY, tiles.ACID_MOVE_W)
						end
					end
				end
			end,
			helpPage = 6
		},
		{
			image = "rotating-gate-we",
			interact = function()
				if laser.dx ~= 0 then
					level.incrementTile(laser.x, laser.y, 1)
					level.setTemporaryTile(laser.x, laser.y, tiles.ROTATING_GATE_WE)
					sounds.play("irismove")
				else
					laser.active = false
					sounds.play("bzzt")
				end
			end,
			helpPage = 6
		},
		{
			image = "rotating-gate-ns",
			interact = function()
				if laser.dy ~= 0 then
					level.incrementTile(laser.x, laser.y, -1)
					level.setTemporaryTile(laser.x, laser.y, tiles.ROTATING_GATE_NS)
					sounds.play("irismove")
				else
					laser.active = false
					sounds.play("bzzt")
				end
			end,
			helpPage = 6
		},
		{
			image = "mirror-ne-sw",
			interact = function()
				if level.moveTile(laser.x, laser.y, laser.dx, laser.dy) then
					sounds.play("bzzt")
				else
					sounds.play("grate")
				end
				laser.active = false
			end,
			helpPage = 3
		},
		{
			image = "mirror-nw-se",
			interact = function()
				if level.moveTile(laser.x, laser.y, laser.dx, laser.dy) then
					sounds.play("bzzt")
				else
					sounds.play("grate")
				end
				laser.active = false
			end,
			helpPage = 3
		},
		{ image = "track-we-damaged", helpPage = 2 }, { image = "track-ns-damaged", helpPage = 2 },
		{ image = "beam-we" }, { image = "beam-ns" },
		{ image = "mirror-nw-bounce" }, { image = "mirror-ne-bounce" }, { image = "mirror-se-bounce" }, { image = "mirror-sw-bounce" },
		{ image = "arrow-n-pressed" }, { image = "arrow-e-pressed" }, { image = "arrow-s-pressed" }, { image = "arrow-w-pressed" },
		{
			image = "iris-open",
			interact = function()
				laser.active = false
				sounds.play("irismove")
				level.setTile(laser.x, laser.y, tiles.BLANK)
				if level.irises > 0 then level.irises = level.irises - 1 end
			end,
			helpPage = 4
		},
		{ image = "track-tank-n-damaged", helpPage = 2 }, { image = "track-tank-e-damaged", helpPage = 2 }, { image = "track-tank-s-damaged", helpPage = 2 }, { image = "track-tank-w-damaged", helpPage = 2 },
		{ image = "acid-move-n" }, { image = "acid-move-e" }, { image = "acid-move-s" }, { image = "acid-move-w" }
	},
	load = function()
		tiles.images = { }
		for i = 1, #tiles.definitions do
			tiles.images[i] = image.load("images/tiles/" .. tiles.definitions[i].image .. ".png")
			tiles[tiles.definitions[i].image:upper():gsub("-", "_")] = i
		end
	end,
	close = function()
		for i = 1, #tiles.images do
			tiles.images[i]:close()
			tiles.images[i] = nil
		end
	end
}